/*
 * NBCT
 * Copyright (c) 2007-2010, Yoshitaka Kameya
 *
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms,  with or without
 * modification,  are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions  in  binary  form  must  reproduce  the  above
 *    copyright notice,  this list of conditions  and  the following
 *    disclaimer  in  the  documentation  and/or   other   materials
 *    provided with the distribution.
 *  * Neither  the  name  of  Tokyo Institute of Technology  nor the
 *    names of its contributors may be used to  endorse  or  promote
 *    products derived from  this  software  without  specific prior
 *    written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS"  AND  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO,  THE IMPLIED WARRANTIES OF MERCHANTABILITY  AND FITNESS
 * FOR  A  PARTICULAR  PURPOSE  ARE  DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL,    SPECIAL,   EXEMPLARY,   OR   CONSEQUENTIAL   DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO,  PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS;  OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT  LIABILITY,  OR  TORT  (INCLUDING  NEGLIGENCE  OR OTHERWISE)
 * ARISING  IN  ANY  WAY  OUT  OF  THE  USE  OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef NBC_EXT_H
#define NBC_EXT_H

extern OPTION nbc_opts[];

extern char fname_base[MAX_FILENAME];
extern char fname_suffix[MAX_FILENAME];
extern char fname_freq[MAX_FILENAME_AUX];
extern char fname_param[MAX_FILENAME_AUX];
extern char fname_hparam[MAX_FILENAME_AUX];
extern char fname_dissim[MAX_FILENAME_AUX];
extern char fname_memp[MAX_FILENAME_AUX];
extern char fname_log[MAX_FILENAME_AUX];
extern char fname_cluster[MAX_FILENAME_AUX];
extern char fname_rank[MAX_FILENAME_AUX];
extern char fname_eval[MAX_FILENAME_AUX];
extern char fname_msg[MAX_FILENAME_AUX];

extern FILE *fp_log;
extern FILE *fp_msg;
extern FILE *fp_sm;
extern int mode_msg;
extern int mode_daem;
#ifdef USE_ICONV
#  ifdef CHARCODE
extern iconv_t cd_sys_in, cd_sys_out;
#  endif
extern iconv_t cd_in, cd_out;
#endif
extern char *buf_crlf;
extern char *buf_base;
extern char *buf_sys;
extern char *buf_delim;
extern char *buf_cout;
extern FLOAT_T stime_read;
extern FLOAT_T stime_em;
extern FLOAT_T stime_memp;
extern FLOAT_T stime_cluster;
extern FLOAT_T stime_eval;
extern FLOAT_T stime_rank;
extern FLOAT_T stime_dissim;
extern FLOAT_T etime_read;
extern FLOAT_T etime_em;
extern FLOAT_T etime_memp;
extern FLOAT_T etime_cluster;
extern FLOAT_T etime_eval;
extern FLOAT_T etime_rank;
extern FLOAT_T etime_dissim;
extern FLOAT_T stime_lap_read;
extern FLOAT_T stime_lap_em;
extern FLOAT_T stime_lap_memp;
extern FLOAT_T stime_lap_cluster;
extern FLOAT_T stime_lap_eval;
extern FLOAT_T stime_lap_rank;
extern FLOAT_T stime_lap_dissim;
extern FLOAT_T etime_lap_read;
extern FLOAT_T etime_lap_em;
extern FLOAT_T etime_lap_memp;
extern FLOAT_T etime_lap_cluster;
extern FLOAT_T etime_lap_eval;
extern FLOAT_T etime_lap_rank;
extern FLOAT_T etime_lap_dissim;

extern int *freq_w_id;

extern int num_class_opt;
extern FREQ_PTR freq_list;
extern int total_freq;
extern int kmin;
extern int kmax;
extern int kstep;
extern int num_entry;
extern int num_entry_pre;
extern int entry_id;
extern FLOAT_T *param_c;
extern FLOAT_T *param_c_opt;
extern FLOAT_T *param_c_best;
extern FLOAT_T *hparam_c;
extern FLOAT_T *read_param_c;
extern FLOAT_T *read_hparam_c;
extern FLOAT_T ***hparam_w;
extern FLOAT_T **prob_comp;
extern FLOAT_T *prob_incomp;
extern FLOAT_T **prob_cond;
extern FLOAT_T *expect_c;
extern int ll_size;
extern FLOAT_T *loglike;
extern FLOAT_T *log_prior;
extern FLOAT_T *lambda;
extern FLOAT_T *loglike_best;
extern FLOAT_T *log_prior_best;
extern FLOAT_T *lambda_best;
extern FLOAT_T final_loglike;
extern FLOAT_T final_log_prior;
extern FLOAT_T final_lambda;
extern FLOAT_T final_loglike_best;
extern FLOAT_T final_log_prior_best;
extern FLOAT_T final_lambda_best;
extern FLOAT_T *ic;
extern FLOAT_T *bic;
extern FLOAT_T *autoclass;
extern unsigned int **log_seed;
extern int **log_num_iterate;
extern int *log_r_best;
extern FLOAT_T **log_final_lambda;

extern int num_sm;
extern int max_candidate;
extern int max_jsplit;
extern int mode_rank_sm;
extern int num_rank_sm;
extern int mode_norm;
extern FLOAT_T min_param_c;
extern FLOAT_T min_smem_improve;
extern FLOAT_T min_new_param_c;
extern int **sm_candidate;
extern FLOAT_T **jmerge;
extern FLOAT_T *norm;
extern FLOAT_T *jsplit;
extern FLOAT_T *param_c_sm;
extern FLOAT_T ***param_w_sm;
extern FLOAT_T ***param_u_sm;
extern FLOAT_T ****param_s_sm;
extern int num_candidate;
extern int *num_iterate_sm_full;
extern int *num_iterate_sm_part;
extern int *num_result_rejected;
extern int *num_result_skipped;
extern FLOAT_T *param_c_part;
extern FLOAT_T *prob_incomp_part;
extern FLOAT_T **prob_cond_part;
extern int *ll_sm_size;
extern FLOAT_T **loglike_sm;
extern FLOAT_T **log_prior_sm;
extern FLOAT_T **lambda_sm;
extern FLOAT_T **log_itemp_sm;
extern FLOAT_T **log_itemp_sm_best;

extern FLOAT_T itemp;
extern FLOAT_T itemp_init;
extern FLOAT_T itemp_rate;
extern FLOAT_T *log_itemp;
extern FLOAT_T *log_itemp_best;
extern FLOAT_T itemp_best;
extern int num_itemp;

extern int mode_verbose;
extern int mode_em;
extern enum file_format format_in, format_out;
extern int mode_conv_in, mode_conv_out;
extern int mode_sys_out;
extern FLOAT_T smooth_default;
extern FLOAT_T smooth_c;
extern int mode_smooth;
extern int mode_smooth_strict;
extern int mode_smooth_auto;
extern int mode_smooth_gauss;
extern int mode_smooth_u;
extern enum smooth_var_type mode_smooth_s;
extern enum smooth_auto_type mode_smooth_auto_c;
extern enum smooth_auto_type *mode_smooth_auto_w;
extern enum smooth_auto_type mode_smooth_auto_tau;
extern int mode_memp;
extern int mode_dissim;
extern int mode_search_num_class;
extern int mode_suffix;
extern int mode_cluster;
extern int mode_set_seed;
extern int mode_lex_order;
extern int mode_rank;
extern int mode_rank_hide;
extern int mode_rank_th;
extern int mode_as_is;
extern int mode_eval;
extern int mode_read_hparam;
extern int mode_id;
extern int mode_ignore;
extern int mode_hide_attr;
extern int num_rank;
extern FLOAT_T rank_th;
extern int num_class;
extern int num_ans_class;
extern int num_case_id;
extern int attr_id;
extern int *attr_ignore;
extern int num_attr_ignore;
extern int attr_eval;
extern int tuple_size;
extern int tuple_size_d;
extern int tuple_size_c;
extern int tuple_size_all;
extern int max_iterate;
extern int num_init;
extern int max_init_iterate;
extern int mode_log_scale;
extern FLOAT_T epsilon;
extern enum info_criterion_type ic_type;
extern enum cluster_type cl_type;
extern enum init_type_for_class init_type_class;
extern enum init_type_for_word init_type_word;
extern enum relevance_measure rel_m;
extern char ic_type_str[ENUM_TYPE_LEN];
extern char cl_type_str[ENUM_TYPE_LEN];
extern char init_type_str_class[ENUM_TYPE_LEN];
extern char init_type_str_word[ENUM_TYPE_LEN];
extern char rel_m_str[ENUM_TYPE_LEN];
extern unsigned int rand_seed;
extern int *rank_class;
#ifdef USE_ICONV
extern char charcode_in[CHARCODE_LEN];
extern char charcode_out[CHARCODE_LEN];
#endif
extern int prec_out;
extern int prec_msg;
extern int mode_uncompress;
extern int mode_show_attr_memp;
extern int mode_show_attr_cluster;
extern int mode_regular_stat;
extern int mode_regular_stat;

extern int **cluster_case_freq_joint;
extern FLOAT_T purity;
extern FLOAT_T purity_inv;
extern FLOAT_T purity_f;
extern FLOAT_T rand_index;
extern FLOAT_T wallance1;
extern FLOAT_T wallance2;
extern FLOAT_T wallance_f;
extern FLOAT_T fowlkes_mallows;
extern FLOAT_T adj_rand_index;
extern FLOAT_T jaccard;
extern FLOAT_T mirkin;
extern FLOAT_T nmi_score;
extern FLOAT_T vi_score;
extern FLOAT_T nvi_score;
extern FLOAT_T weight_purity;
extern FLOAT_T weight_wallance;

extern HASHTABLE *ht;
extern HASHTABLE ht_vec;
extern HASHTABLE ht_class;
extern HASHTABLE ht_case_id;

extern ATTR_INFO *attr_info;

extern int mode_gauss;
extern int mode_nominal;
extern GAUSS_PTR gauss_list;
extern int gauss_size;
extern int *gauss_attr_size;
extern int **gauss_attr;

extern int err_inv;
extern int err_det;
extern int err_lu;
extern int err_cho;

extern int *num_word;
extern char ***word_list;
extern int *num_miss_w;
extern int *num_miss_g;
extern int total_num_miss_w;
extern int total_num_miss_g;
extern int **word_freq_list;
extern char **case_id_list;
extern char **ans_class_list;
extern int **print_order;
extern int **cluster_case;
extern int *cluster_case_pred;
extern int *cluster_case_freq;
extern int *cluster_case_freq_ans;
extern int ***cluster_w;
extern int **cluster_w_pred;
extern int **cluster_w_freq;
extern int ***cluster_g;
extern int **cluster_g_pred;
extern int **cluster_g_freq;
extern FLOAT_T ***param_w;
extern FLOAT_T ***param_w_opt;
extern FLOAT_T ***param_w_best;
extern FLOAT_T ***read_param_w;
extern FLOAT_T ***read_hparam_w;
extern FLOAT_T ***expect_w;
extern FLOAT_T *prob_case;
extern FLOAT_T **prob_w;
extern FLOAT_T **prob_g;
extern FLOAT_T **prob_mem_case;
extern FLOAT_T ***prob_mem_w;
extern FLOAT_T ***prob_mem_g;
extern FLOAT_T **prob_compo_case;
extern FLOAT_T ***prob_compo_w;
extern FLOAT_T ***prob_compo_g;
extern int **rank_mem_case;
extern int ***rank_mem_w;
extern int ***rank_mem_g;
extern FLOAT_T *smooth_w;
extern VECTOR **param_u;
extern VECTOR **param_u_opt;
extern VECTOR **param_u_best;
extern MATRIX **param_s;
extern MATRIX **param_s_opt;
extern MATRIX **param_s_best;
extern MATRIX **param_p;
extern FLOAT_T **param_sdet;
extern VECTOR **hparam_u;
extern MATRIX **hparam_s;
extern MATRIX **hparam_p;
extern FLOAT_T **hparam_sdet;
extern FLOAT_T ***read_param_u;
extern FLOAT_T ***read_hparam_u;
extern FLOAT_T ****read_param_s;
extern FLOAT_T ****read_hparam_s;
extern FLOAT_T *read_tau;
extern FLOAT_T **read_alpha_w;
extern FLOAT_T *hparam_tau;
extern FLOAT_T **hparam_alpha_w;
extern VECTOR **expect_u;
extern MATRIX **expect_s;
extern VECTOR *sample_u;
extern MATRIX *sample_s;
extern VECTOR *sample_u_raw;
extern MATRIX *sample_s_raw;
extern VECTOR *regular_u;
extern MATRIX *regular_s;
extern VECTOR *regular_min;
extern VECTOR *regular_max;
extern FLOAT_T noise_ratio;
extern FLOAT_T noise_ratio_gauss;
extern FLOAT_T q_regular_min;
extern FLOAT_T q_regular_max;
extern FLOAT_T smooth_u;
extern FLOAT_T smooth_s;
extern FLOAT_T tau;
extern FLOAT_T alpha_w;

extern struct STAT *attr_stat;

extern char **tmp_word_list;

#endif /* NBC_EXT_H */
